Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #466

Qt: Translations are not applied
October 14, 2014 15:58 - Thomas Lange

Status: Closed Start date: October 14, 2014
Priority: Major Due date:

Assignee: % Done: 100%

Category: plugins/qtui Estimated time: 0.00 hour

Target version: 3.7

Affects version:

Description
Almost all strings are shown in English with the Qt interface.

Only some window titles and buttons use the translations
(screenshot of the settings window is attached).

Platform: Linux

History

#1 - October 14, 2014 16:47 - John Lindgren
- Target version deleted (3.6)
- Category changed from libaudqt to plugins/qtui

- Priority changed from Blocker to Major

| don't think this should be a blocker for 3.6 since the Qt Ul is only going to be a technical preview in that release. Some of the translations will not
appear without a fair amount of work, since Qt Designer does not support our gettext-based translations.

#2 - October 17, 2014 21:44 - Ariadne Conill

| am planning to remove the last bits of the Qt Designer stuff this weekend.

#3 - October 26, 2014 17:13 - John Lindgren

| fixed several issues in the PreferencesWidget code; all of the settings dialog should be translated now.

#4 - October 27, 2014 01:05 - Thomas Lange

- Status changed from New to In Progress

Thanks John, good work.
| just fixed some remaining issues.

TODO:

- menu bar

- dialog buttons

- combobox "Preferences->Audio->Bit depth”

- combobox "Preferences->Playlist->Auto character encoding detector for:"
- tooltip "Close Tab" on tab close buttons

The dialog buttons and the tooltip should be translated by Qt, but apparently they are not.
We could either use custom QPushButtons or something like this:

m_buttonbox.setStandardButtons (QDialogButtonBox::0k | QDialogButtonBox::Cancel);

+ m_buttonbox.button (QDialogButtonBox::0k)->setText (translate_str ("_OK"));
+ m_buttonbox.button (QDialogButtonBox::Cancel)->setText (translate_str ("_Cancel"));
#5 - October 29, 2014 00:40 - Ariadne Conill

Qt designer vestiges have been nuked. The menus should now be translated.

#6 - October 29, 2014 01:37 - Thomas Lange

At first it still used the English strings, but the fix was trivial.
Using () instead of N() resolved it.

#7 - October 29, 2014 01:46 - Ariadne Conill

That fix is incorrect. Please revert.

#8 - October 29, 2014 02:00 - Thomas Lange

Done, sorry for the inconvenience.
What is the proper fix though?

#9 - October 29, 2014 02:02 - Ariadne Conill

Please try latest libaudqt, it should have an appropriate fix.

#10 - October 29, 2014 02:09 - Thomas Lange

It is the same as before, still not translated.

#11 - October 29, 2014 02:17 - Ariadne Conill

Best to leave it to jlindgren then, the current approach is the same as libaudgui basically.

#12 - October 30, 2014 22:58 - Ariadne Conill

Qt itself can be translated by installing a custom translator which is subclassed from QTranslator. I'll work on that this weekend, it might help.

#13 - October 31, 2014 23:45 - John Lindgren

William Pitcock wrote:

Best to leave it to jlindgren then, the current approach is the same as libaudgui basically.

One of the pitfalls of this approach is that it's easy for the gettext domain to get dropped at some point in the call tree. There were a couple of places
where this was happening in libaudgt. Menu translations should be fixed now.

#14 - November 01, 2014 15:02 - Thomas Lange

John Lindgren wrote:

Menu translations should be fixed now.

Thanks, confirming it works.
#15 - December 06, 2014 01:09 - Thomas Lange

Another issue remains in the file dialog (libaudqt/fileopener.cc#46).

If we translate the button label with "translate_str (N_("_Add"))", the accelerator

is converted to the Qt one (&). But Qt itself uses on GTK systems a native GTK dialog
and in this case the string is shown literally as "&Add".

If we just use _("_Add"), the accelerator is wrong on Qt systems.

Additionally it would be nice to show an icon on this button.

#16 - February 12, 2015 19:09 - Thomas Lange
- File translate_qt_buttons.patch added

With the attached patch all dialog buttons are translatable.
The strings are already used in the GTK interface so no further translation work is needed.

My suggestion is to use this solution until William implements a custom QTranslator.

#17 - February 13, 2015 00:41 - John Lindgren

Looks fine to me.

#18 - June 20, 2015 00:40 - Thomas Lange
- Affects version deleted (3.6)

Update for 3.7-devel:

PreferencesWidgets in "/skins-qt/skins_cfg.cc" are not shown translated currently.

#19 - June 20, 2015 04:34 - John Lindgren
https://github.com/audacious-media-player/audacious/commit/d2e2e7bc52c694871e34585e91e641ee4c27bd52

#20 - July 18, 2015 18:43 - John Lindgren
- Status changed from In Progress to Closed
- Target version set to 3.7

- % Done changed from 0 to 100

Closing this since it looks like the issues have all been fixed.

Files
Settings.png 42.1 KB October 14, 2014 Thomas Lange
translate_qt_buttons.patch 4.04 KB February 12,2015 Thomas Lange
